/****************************************
Ez az llomny kizrolag az Effice Kft. (2083 Solymr Toldi u. 21.) tulajdona,
kizrolag csak az Effice Kft. engedlyvel, az engedlyben meghatrozott clra
s mdon hasznlhat fel. A program ingyenesen trtnt tadsra, mkdsrt 
az Effice Kft. semmilyen felelssget nem vllal.

Interface client for socket based communication.
Example Program for set status an orderentry.
****************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifndef WIN32
#  include <unistd.h>
#else 
#  include <wtypes.h>
#  include <winbase.h>
#endif


#include "ifsapi.h"
#include "ifsdefs.h"
#include "ifsutil.h"

static char Id[] = "mmorder_status ";

	/*+ trace flag +*/	
static int trace;
        /* Prototypes */
int main (int argc, char *argv[]);
void usage( void);

/*+++++++++++++++++++++++++++++++++++++++++
Prints usage information.
+++++++++++++++++++++++++++++++++++++++++*/
void usage( void){
  fprintf(stderr, "Usage -oorderid -Sstatus [-t] [-hhost] [-sservice] [-uuser] [-ppwd] [-h]\n");
  fprintf(stderr, "  -oorderid  id of orderentry record\n");
  fprintf(stderr, "  -sstatus   new status of the orderentry record\n");
  fprintf(stderr, "  -t 	     trace\n");
  fprintf(stderr, "  -hhost     host name of server\n");
  fprintf(stderr, "  -sservice  service name of server\n");
  fprintf(stderr, "  -uuser     user name\n");
  fprintf(stderr, "  -pwd       password\n");
  fprintf(stderr, "  -h         prints this information\n");
  fprintf(stderr, "If no host, service, user, pwd defined then \n");
  fprintf(stderr, "  value of IFSHOST, IFSSERVICE, IFSHOST, IFSPWD environment used\n");
  exit(1);    
}

/*+++++++++++++++++++++++++++++++++++++++++
Socket based communication interface client. Clients can connect into this server to 
sending an orderentry_status_chg.

int main Tradition.

int argc Number of command line parameters.

char *argv[] Points to an array that contains the command line parameters.
+++++++++++++++++++++++++++++++++++++++++*/
int main (int argc, char *argv[])
{
  int i;
  int tradeid;
  int pid;
  int mmts_type;
  int orderid = 0;
  char * host = NULL;
  char * service = NULL;
  char * user = NULL;
  char * pwd = NULL;
  char order_status;
  int s;
  IFSC_HDL handle;

  host = getenv("IFSHOST");
  service = getenv("IFSSERVICE");
  user = getenv("IFSUSER");
  pwd = getenv("IFSPWD");

  if (argc == 1) usage();
  for (i = 1; i < argc; i++){
    if (argv[i][0] == '-'){
      switch(argv[i][1]){
        case 'o':
          orderid = atoi(argv[i] + 2); 
          break;
        case 'S':
          order_status = *(argv[i] + 2);
          break;
        case 't': 
          trace = 1; 
          break;
        case 'h':
          host = argv[i]+2;
          break;
        case 's':
          service = argv[i]+2;
          break;
        case 'u':
          user = argv[i]+2;
          break;
        case 'p':
          pwd = argv[i]+2;
          break;
        case '?':
        case '-':
          usage();
          break;
      }
    } 
  }

  if (trace) fprintf (stderr, "%s Compiled: %s %s\n", Id, __DATE__, __TIME__);

  if (!orderid) {
    fprintf(stderr, "-oorderid is not defined!\n");
    usage();
  }

  if (!host) {
    fprintf(stderr, "The host is not defined!\n");
    usage();
  }

  if (!service) {
    fprintf(stderr, "The service is not defined!\n");
    usage();
  }

  if (!user) {
    fprintf(stderr, "The user is not defined!\n");
    usage();
  }

  if (!pwd) {
    fprintf(stderr, "The pwd is not defined!\n");
    usage();
  }

  if (ifsc_create(&handle, host, service)) {
    fprintf(stderr, "Error at connection: %s\n", ifsc_get_last_errmsg(handle));
    exit(1);
  }

  if (trace)
    ifsc_set_trace(handle, IFS_SWITCH_ON);

  if (ifsc_connect(handle, user, pwd, &tradeid, &pid, &mmts_type)) {
    fprintf(stderr, "Error at connection: %s\n", ifsc_get_last_errmsg(handle));
    exit(1);
  }

  if ((s = ifsc_mmorder_status_chg(handle, orderid, order_status)) == IFS_OK) {
    if (trace) fprintf (stderr, " order status change (orderid %d) sent\n", orderid);
  } 
  else
    fprintf (stderr, " error at order status change - %s\n", ifsc_get_last_errmsg(handle));

  return ifsc_disconnect(handle);
}
